#! /usr/bin/perl -w

#
# doc-index.pl
# copyright (c) 2002 by Deliana Foutekova <unjm@stud.uni-karlsruhe.de>
#

use CGI qw(param url);

# list of lines.
# each line is a list of things separated by ';'.
# these things are: package symbol kind url
@lines = (
"XLIB;access-control;Function ;14_6_Managing_Host_Access.html#access-control;",
"XLIB;access-error;Condition ;16_1_Introduction.html#access-error;",
"XLIB;access-hosts;Function ;14_6_Managing_Host_Access.html#access-hosts;",
"XLIB;activate-screen-saver;Function ;14_7_Screen_Saver.html#activate-screen-saver;",
"XLIB;add-access-host;Function ;14_6_Managing_Host_Access.html#add-access-host;",
"XLIB;add-resource;Function ;13_3_Basic_Resource_Database_Functions.html#add-resource;",
"XLIB;add-to-save-set;Function ;14_5_Client_Termination.html#add-to-save-set;",
"XLIB;alist;Type ;1_6_Data_Types.html#alist;",
"XLIB;alloc-color;Function ;9_3_3_Allocating_Colors.html#alloc-color;",
"XLIB;alloc-color-cells;Function ;9_3_3_Allocating_Colors.html#alloc-color-cells;",
"XLIB;alloc-color-planes;Function ;9_3_3_Allocating_Colors.html#alloc-color-planes;",
"XLIB;alloc-error;Condition ;16_1_Introduction.html#alloc-error;",
"XLIB;allow-events;Function ;12_13_Releasing_Queued_Events.html#allow-events;",
"XLIB;angle;Type ;1_6_Data_Types.html#angle;",
"XLIB;arc-seq;Type ;1_6_Data_Types.html#arc-seq;",
"XLIB;array-index;Type ;1_6_Data_Types.html#array-index;",
"XLIB;atom-error;Condition ;16_1_Introduction.html#atom-error;",
"XLIB;atom-name;Function ;11_1_Atoms.html#atom-name;",
"XLIB;bell;Function ;14_3_Keyboard_Control.html#bell;",
"XLIB;bit-gravity;Type ;1_6_Data_Types.html#bit-gravity;",
"XLIB;bitmap;Type ;1_6_Data_Types.html#bitmap;",
"XLIB;bitmap-format;Structure ;1_6_Data_Types.html#bitmap-format;",
"XLIB;bitmap-image;Function;17_Undocmented.html#bitmap-image;",
"XLIB;bits-per-pixel;Slot of pixmap-format ;1_6_Data_Types.html#bits-per-pixel;",
"XLIB;bits-per-rgb;Slot of visual-info ;1_6_Data_Types.html#bits-per-rgb;",
"XLIB;blue-mask;Slots of visual-info ;1_6_Data_Types.html#blue-mask;",
"XLIB;boolean;Type ;1_6_Data_Types.html#boolean;",
"XLIB;boole-constant;Type ;1_6_Data_Types.html#boole-constant;",
"XLIB;:button-press;Event Type ;12_12_1_Keyboard_and_Pointer_Events.html#:button-press;",
"XLIB;:button-release;Event Type ;12_12_1_Keyboard_and_Pointer_Events.html#:button-release;",
"XLIB;card16;Type ;1_6_Data_Types.html#card16;",
"XLIB;card29;Type ;1_6_Data_Types.html#card29;",
"XLIB;card32;Type ;1_6_Data_Types.html#card32;",
"XLIB;card8;Type ;1_6_Data_Types.html#card8;",
"XLIB;change-active-pointer-grab;Function ;12_8_Grabbing_the_Pointer.html#change-active-pointer-grab;",
"XLIB;change-keyboard-control;Function ;14_3_Keyboard_Control.html#change-keyboard-control;",
"XLIB;change-keyboard-mapping;Function ;14_4_2_Keyboard_Mapping.html#change-keyboard-mapping;",
"XLIB;change-pointer-control;Function ;14_2_Pointer_Control.html#change-pointer-control;",
"XLIB;change-property;Function ;11_2_Properties.html#change-property;",
"XLIB;character-in-map-p;Function;17_Undocmented.html#character-in-map-p;",
"XLIB;character->keysyms;Function;17_Undocmented.html#character->keysyms;",
"XLIB;char-ascent;Function ;8_5_Chracter_Attributes.html#char-ascent;",
"XLIB;char-attributes;Function ;8_5_Chracter_Attributes.html#char-attributes;",
"XLIB;char-descent;Function ;8_5_Chracter_Attributes.html#char-descent;",
"XLIB;char-left-bearing;Function ;8_5_Chracter_Attributes.html#char-left-bearing;",
"XLIB;char-right-bearing;Function ;8_5_Chracter_Attributes.html#char-right-bearing;",
"XLIB;char-width;Function ;8_5_Chracter_Attributes.html#char-width;",
"XLIB;:circulate-notify;Event Type ;12_12_5_Window_State_Events.html#:circulate-notify;",
"XLIB;:circulate-request;Event Type ;12_12_6_Structure_Control_Events.html#:circulate-request;",
"XLIB;circulate-window-down;Function ;4_4_Stacking_Order.html#circulate-window-down;",
"XLIB;circulate-window-up;Function ;4_4_Stacking_Order.html#circulate-window-up;",
"XLIB;class;Slot of visual-info ;1_6_Data_Types.html#class;",
"XLIB;clear-area;Function ;6_2_Area_and_Plane_Operations.html#clear-area;",
"XLIB;:client-message;Event Type ;12_12_7_Client_Communications_Events.html#:client-message;",
"XLIB;closed-display;Condition ;16_1_Introduction.html#closed-display;",
"XLIB;close-display;Function ;2_5_Closing_the_Display.html#close-display;",
"XLIB;close-down-mode;Function ;14_5_Client_Termination.html#close-down-mode;",
"XLIB;close-font;Function ;8_2_Opening_Fonts.html#close-font;",
"XLIB;color;Type ;1_6_Data_Types.html#color;",
"XLIB;color-blue;Function ;9_2_Color_Functions.html#color-blue;",
"XLIB;color-green;Function ;9_2_Color_Functions.html#color-green;",
"XLIB;colormap;Type ;1_6_Data_Types.html#colormap;",
"XLIB;colormap-display;Function ;9_3_6_Colormap_Attributes.html#colormap-display;",
"XLIB;colormap-entries;Slot of visual-info ;1_6_Data_Types.html#colormap-entries;",
"XLIB;colormap-equal;Function ;9_3_6_Colormap_Attributes.html#colormap-equal;",
"XLIB;colormap-error;Condition ;16_1_Introduction.html#colormap-error;",
"XLIB;colormap-id;Function ;9_3_6_Colormap_Attributes.html#colormap-id;",
"XLIB;:colormap-notify;Event Type ;12_12_6_Structure_Control_Events.html#:colormap-notify;",
"XLIB;colormap-p;Function ;9_3_6_Colormap_Attributes.html#colormap-p;",
"XLIB;colormap-plist;Function ;9_3_6_Colormap_Attributes.html#colormap-plist;",
"XLIB;color-p;Function ;9_2_Color_Functions.html#color-p;",
"XLIB;color-red;Function ;9_2_Color_Functions.html#color-red;",
"XLIB;color-rgb;Function ;9_2_Color_Functions.html#color-rgb;",
"XLIB;:configure-notify;Event Type ;12_12_5_Window_State_Events.html#:configure-notify;",
"XLIB;:configure-request;Event Type ;12_12_6_Structure_Control_Events.html#:configure-request;",
"XLIB;connection-failure;Condition ;16_1_Introduction.html#connection-failure;",
"XLIB;convert-selection;Function ;11_3_Selections.html#convert-selection;",
"XLIB;copy-area;Function ;6_2_Area_and_Plane_Operations.html#copy-area;",
"XLIB;copy-colormap-and-free;Function ;9_3_1_Creating_Colormaps.html#copy-colormap-and-free;",
"XLIB;copy-gcontext;Function ;5_3_Copying_Graphics_Contexts.html#copy-gcontext;",
"XLIB;copy-gcontext-components;Function ;5_3_Copying_Graphics_Contexts.html#copy-gcontext-components;",
"XLIB;copy-image;Function ;7_3_Image_Functions.html#copy-image;",
"XLIB;copy-plane;Function ;6_2_Area_and_Plane_Operations.html#copy-plane;",
"XLIB;create-colormap;Function ;9_3_1_Creating_Colormaps.html#create-colormap;",
"XLIB;create-cursor;Function ;10_2_Creating_Cursors.html#create-cursor;",
"XLIB;create-gcontext;Function ;5_2_Creating_Graphics_Contexts.html#create-gcontext;",
"XLIB;create-glyph-cursor;Function ;10_2_Creating_Cursors.html#create-glyph-cursor;",
"XLIB;create-image;Function ;7_3_Image_Functions.html#create-image;",
"XLIB;:create-notify;Event Type ;12_12_5_Window_State_Events.html#:create-notify;",
"XLIB;create-pixmap;Function ;4_8_Pixmaps.html#create-pixmap;",
"XLIB;create-window;Function ;4_2_Creating_Windows.html#create-window;",
"XLIB;cursor;Type ;1_6_Data_Types.html#cursor;",
"XLIB;cursor-display;Function ;10_4_Cursor_Attributes.html#cursor-display;",
"XLIB;cursor-equal;Function ;10_4_Cursor_Attributes.html#cursor-equal;",
"XLIB;cursor-error;Condition ;16_1_Introduction.html#cursor-error;",
"XLIB;cursor-id;Function ;10_4_Cursor_Attributes.html#cursor-id;",
"XLIB;cursor-p;Function ;10_4_Cursor_Attributes.html#cursor-p;",
"XLIB;cursor-plist;Function ;10_4_Cursor_Attributes.html#cursor-plist;",
"XLIB;declare-event;Macro ;12_12_8_Declaring_Event_Types.html#declare-event;",
"XLIB;decode-core-error;Function;17_Undocmented.html#decode-core-error;",
"XLIB;default-error-handler;Function;17_Undocmented.html#default-error-handler;",
"XLIB;default-keysym-index;Function;17_Undocmented.html#default-keysym-index;",
"XLIB;default-keysym-translate;Function;17_Undocmented.html#default-keysym-translate;",
"XLIB;define-condition;Macro ;16_1_Introduction.html#define-condition;",
"XLIB;define-keysym;Function;17_Undocmented.html#define-keysym;",
"XLIB;define-keysym-set;Function;17_Undocmented.html#define-keysym-set;",
"XLIB;delete-property;Function ;11_2_Properties.html#delete-property;",
"XLIB;delete-resource;Function ;13_3_Basic_Resource_Database_Functions.html#delete-resource;",
"XLIB;depth;Slot of pixmap-format ;1_6_Data_Types.html#depth;",
"XLIB;:destroy-notify;Event Type ;12_12_5_Window_State_Events.html#:destroy-notify;",
"XLIB;destroy-subwindows;Function ;4_7_Destroying_Windows.html#destroy-subwindows;",
"XLIB;destroy-window;Function ;4_7_Destroying_Windows.html#destroy-window;",
"XLIB;device-busy;Condition ;16_1_Introduction.html#device-busy;",
"XLIB;device-event-mask;Type ;1_6_Data_Types.html#device-event-mask;",
"XLIB;device-event-mask-class;Type ;1_6_Data_Types.html#device-event-mask-class;",
"XLIB;discard-current-event;Function ;12_4_Managing_the_Event_Queue.html#discard-current-event;",
"XLIB;discard-font-info;Function ;8_2_Opening_Fonts.html#discard-font-info;",
"XLIB;display;Type ;1_6_Data_Types.html#display;",
"XLIB;display-after-function;Function ;2_4_Managing_the_Output_Buffer.html#display-after-function;",
"XLIB;display-authorization-data;Function ;2_3_Display_Attributes.html#display-authorization-data;",
"XLIB;display-authorization-name;Function ;2_3_Display_Attributes.html#display-authorization-name;",
"XLIB;display-bitmap-format;Function ;2_3_Display_Attributes.html#display-bitmap-format;",
"XLIB;display-byte-order;Function ;2_3_Display_Attributes.html#display-byte-order;",
"XLIB;display-display;Function ;2_3_Display_Attributes.html#display-display;",
"XLIB;display-error-handler;Function ;2_3_Display_Attributes.html#display-error-handler;",
"XLIB;display-finish-output;Function ;2_4_Managing_the_Output_Buffer.html#display-finish-output;",
"XLIB;display-force-output;Function ;2_4_Managing_the_Output_Buffer.html#display-force-output;",
"XLIB;display-image-lsb-first-p;Function ;2_3_Display_Attributes.html#display-image-lsb-first-p;",
"XLIB;display-invoke-after-function;Function ;17_Undocmented.html#display-invoke-after-function;",
"XLIB;display-keycode-range;Function ;2_3_Display_Attributes.html#display-keycode-range;",
"XLIB;display-max-keycode;Function ;2_3_Display_Attributes.html#display-max-keycode;",
"XLIB;display-max-request-length;Function ;2_3_Display_Attributes.html#display-max-request-length;",
"XLIB;display-min-keycode;Function ;2_3_Display_Attributes.html#display-min-keycode;",
"XLIB;display-motion-buffer-size;Function ;2_3_Display_Attributes.html#display-motion-buffer-size;",
"XLIB;display-nscreens;Function;17_Undocmented.html#display-nscreens;",
"XLIB;display-p;Function ;2_3_Display_Attributes.html#display-p;",
"XLIB;display-pixmap-formats;Function ;2_3_Display_Attributes.html#display-pixmap-formats;",
"XLIB;display-plist;Function ;2_3_Display_Attributes.html#display-plist;",
"XLIB;display-protocol-major-version;Function ;2_3_Display_Attributes.html#display-protocol-major-version;",
"XLIB;display-protocol-minor-version;Function ;2_3_Display_Attributes.html#display-protocol-minor-version;",
"XLIB;display-protocol-version;Function ;2_3_Display_Attributes.html#display-protocol-version;",
"XLIB;display-release-number;Function;17_Undocmented.html#display-release-number;",
"XLIB;display-resource-id-base;Function ;2_3_Display_Attributes.html#display-resource-id-base;",
"XLIB;display-resource-id-mask;Function ;2_3_Display_Attributes.html#display-resource-id-mask;",
"XLIB;display-roots;Function ;2_3_Display_Attributes.html#display-roots;",
"XLIB;display-vendor;Function ;2_3_Display_Attributes.html#display-vendor;",
"XLIB;display-vendor-name;Function ;2_3_Display_Attributes.html#display-vendor-name;",
"XLIB;display-version-number;Function ;2_3_Display_Attributes.html#display-version-number;",
"XLIB;display-xid;Function ;2_3_Display_Attributes.html#display-xid;",
"XLIB;drawable;Type ;1_6_Data_Types.html#drawable;",
"XLIB;drawable-border-width;Function ;4_3_Window_Attributes.html#drawable-border-width;",
"XLIB;drawable-depth;Function ;4_3_Window_Attributes.html#drawable-depth;",
"XLIB;drawable-display;Function ;4_1_Drawables.html#drawable-display;",
"XLIB;drawable-equal;Function ;4_1_Drawables.html#drawable-equal;",
"XLIB;drawable-error;Condition ;16_1_Introduction.html#drawable-error;",
"XLIB;drawable-height;Function ;4_3_Window_Attributes.html#drawable-height;",
"XLIB;drawable-id;Function ;4_1_Drawables.html#drawable-id;",
"XLIB;drawable-p;Function ;4_1_Drawables.html#drawable-p;",
"XLIB;drawable-plist;Function ;4_1_Drawables.html#drawable-plist;",
"XLIB;drawable-root;Function ;4_5_Window_Hierarchy.html#drawable-root;",
"XLIB;drawable-width;Function ;4_3_Window_Attributes.html#drawable-width;",
"XLIB;drawable-x;Function ;4_3_Window_Attributes.html#drawable-x;",
"XLIB;drawable-y;Function ;4_3_Window_Attributes.html#drawable-y;",
"XLIB;draw-arc;Function ;6_6_Drawing_Arcs.html#draw-arc;",
"XLIB;draw-arcs;Function ;6_6_Drawing_Arcs.html#draw-arcs;",
"XLIB;draw-direction;Type ;1_6_Data_Types.html#draw-direction;",
"XLIB;draw-glyph;Function ;6_7_Drawing_Text.html#draw-glyph;",
"XLIB;draw-glyphs;Function ;6_7_Drawing_Text.html#draw-glyphs;",
"XLIB;draw-image-glyph;Function ;6_7_Drawing_Text.html#draw-image-glyph;",
"XLIB;draw-image-glyphs;Function ;6_7_Drawing_Text.html#draw-image-glyphs;",
"XLIB;draw-line;Function ;6_4_Drawing_Lines.html#draw-line;",
"XLIB;draw-lines;Function ;6_4_Drawing_Lines.html#draw-lines;",
"XLIB;draw-point;Function ;6_3_Drawing_Points.html#draw-point;",
"XLIB;draw-points;Function ;6_3_Drawing_Points.html#draw-points;",
"XLIB;draw-rectangle;Function ;6_5_Drawing_Rectangles.html#draw-rectangle;",
"XLIB;draw-rectangles;Function ;6_5_Drawing_Rectangles.html#draw-rectangles;",
"XLIB;draw-segments;Function ;6_4_Drawing_Lines.html#draw-segments;",
"XLIB;:enter-notify;Event Type ;12_12_1_Keyboard_and_Pointer_Events.html#:enter-notify;",
"XLIB;error-key;Type ;1_6_Data_Types.html#error-key;",
"XLIB;event-case;Macro ;12_3_Processing_Events.html#event-case;",
"XLIB;event-cond;Macro ;12_3_Processing_Events.html#event-cond;",
"XLIB;event-handler;Function;17_Undocmented.html#event-handler;",
"XLIB;event-key;Type ;1_6_Data_Types.html#event-key;",
"XLIB;event-listen;Function ;12_4_Managing_the_Event_Queue.html#event-listen;",
"XLIB;event-mask;Type ;1_6_Data_Types.html#event-mask;",
"XLIB;event-mask-class;Type ;1_6_Data_Types.html#event-mask-class;",
"XLIB;:exposure;Event Type ;12_12_4_Exposure_Events.html#:exposure;",
"XLIB;find-atom;Function ;11_1_Atoms.html#find-atom;",
"XLIB;:focus-in;Event Type ;12_12_2_Input_Focus_Events.html#:focus-in;",
"XLIB;:focus-out;Event Type ;12_12_2_Input_Focus_Events.html#:focus-out;",
"XLIB;font;Type ;1_6_Data_Types.html#font;",
"XLIB;fontable;Type ;1_6_Data_Types.html#fontable;",
"XLIB;font-all-chars-exist-p;Function ;8_4_Font_Attributes.html#font-all-chars-exist-p;",
"XLIB;font-ascent;Function ;8_4_Font_Attributes.html#font-ascent;",
"XLIB;font-default-char;Function ;8_4_Font_Attributes.html#font-default-char;",
"XLIB;font-descent;Function ;8_4_Font_Attributes.html#font-descent;",
"XLIB;font-direction;Function ;8_4_Font_Attributes.html#font-direction;",
"XLIB;font-display;Function ;8_4_Font_Attributes.html#font-display;",
"XLIB;font-equal;Function ;8_4_Font_Attributes.html#font-equal;",
"XLIB;font-error;Condition ;16_1_Introduction.html#font-error;",
"XLIB;font-id;Function ;8_4_Font_Attributes.html#font-id;",
"XLIB;font-max-byte1;Function ;8_4_Font_Attributes.html#font-max-byte1;",
"XLIB;font-max-byte2;Function ;8_4_Font_Attributes.html#font-max-byte2;",
"XLIB;font-max-char;Function ;8_4_Font_Attributes.html#font-max-char;",
"XLIB;font-min-byte1;Function ;8_4_Font_Attributes.html#font-min-byte1;",
"XLIB;font-min-byte2;Function ;8_4_Font_Attributes.html#font-min-byte2;",
"XLIB;font-min-char;Function ;8_4_Font_Attributes.html#font-min-char;",
"XLIB;font-name;Function ;8_4_Font_Attributes.html#font-name;",
"XLIB;font-p;Function ;8_4_Font_Attributes.html#font-p;",
"XLIB;font-path;Function ;8_3_Listing_Fonts.html#font-path;",
"XLIB;font-plist;Function ;8_4_Font_Attributes.html#font-plist;",
"XLIB;font-properties;Function ;8_4_Font_Attributes.html#font-properties;",
"XLIB;font-property;Function ;8_4_Font_Attributes.html#font-property;",
"XLIB;font-props;Type ;1_6_Data_Types.html#font-props;",
"XLIB;force-gcontext-changes;Function ;5_6_Graphics_Context_Cache.html#force-gcontext-changes;",
"XLIB;free-colormap;Function ;9_3_1_Creating_Colormaps.html#free-colormap;",
"XLIB;free-colors;Function ;9_3_3_Allocating_Colors.html#free-colors;",
"XLIB;free-cursor;Function ;10_2_Creating_Cursors.html#free-cursor;",
"XLIB;free-gcontext;Function ;5_5_Destroying_Graphics_Contexts.html#free-gcontext;",
"XLIB;free-pixmap;Function ;4_8_Pixmaps.html#free-pixmap;",
"XLIB;gcontext;Type ;1_6_Data_Types.html#gcontext;",
"XLIB;gcontext-arc-mode;Function ;5_3_Graphics_Context_Attributes.html#gcontext-arc-mode;",
"XLIB;gcontext-background;Function ;5_3_Graphics_Context_Attributes.html#gcontext-background;",
"XLIB;gcontext-cache-p;Function ;5_3_Graphics_Context_Attributes.html#gcontext-cache-p;",
"XLIB;gcontext-cap-style;Function ;5_3_Graphics_Context_Attributes.html#gcontext-cap-style;",
"XLIB;gcontext-clip-mask;Function ;5_3_Graphics_Context_Attributes.html#gcontext-clip-mask;",
"XLIB;gcontext-clip-x;Function ;5_3_Graphics_Context_Attributes.html#gcontext-clip-x;",
"XLIB;gcontext-clip-y;Function ;5_3_Graphics_Context_Attributes.html#gcontext-clip-y;",
"XLIB;gcontext-dashes;Function ;5_3_Graphics_Context_Attributes.html#gcontext-dashes;",
"XLIB;gcontext-dash-offset;Function ;5_3_Graphics_Context_Attributes.html#gcontext-dash-offset;",
"XLIB;gcontext-display;Function ;5_3_Graphics_Context_Attributes.html#gcontext-display;",
"XLIB;gcontext-equal;Function ;5_3_Graphics_Context_Attributes.html#gcontext-equal;",
"XLIB;gcontext-error;Condition ;16_1_Introduction.html#gcontext-error;",
"XLIB;gcontext-exposures;Function ;5_3_Graphics_Context_Attributes.html#gcontext-exposures;",
"XLIB;gcontext-fill-rule;Function ;5_3_Graphics_Context_Attributes.html#gcontext-fill-rule;",
"XLIB;gcontext-fill-style;Function ;5_3_Graphics_Context_Attributes.html#gcontext-fill-style;",
"XLIB;gcontext-font;Function ;5_3_Graphics_Context_Attributes.html#gcontext-font;",
"XLIB;gcontext-foreground;Function ;5_3_Graphics_Context_Attributes.html#gcontext-foreground;",
"XLIB;gcontext-function;Function ;5_3_Graphics_Context_Attributes.html#gcontext-function;",
"XLIB;gcontext-id;Function ;5_3_Graphics_Context_Attributes.html#gcontext-id;",
"XLIB;gcontext-join-style;Function ;5_3_Graphics_Context_Attributes.html#gcontext-join-style;",
"XLIB;gcontext-key;Type ;1_6_Data_Types.html#gcontext-key;",
"XLIB;gcontext-line-style;Function ;5_3_Graphics_Context_Attributes.html#gcontext-line-style;",
"XLIB;gcontext-line-width;Function ;5_3_Graphics_Context_Attributes.html#gcontext-line-width;",
"XLIB;gcontext-p;Function ;5_3_Graphics_Context_Attributes.html#gcontext-p;",
"XLIB;gcontext-plane-mask;Function ;5_3_Graphics_Context_Attributes.html#gcontext-plane-mask;",
"XLIB;gcontext-plist;Function ;5_3_Graphics_Context_Attributes.html#gcontext-plist;",
"XLIB;gcontext-stipple;Function ;5_3_Graphics_Context_Attributes.html#gcontext-stipple;",
"XLIB;gcontext-subwindow-mode;Function ;5_3_Graphics_Context_Attributes.html#gcontext-subwindow-mode;",
"XLIB;gcontext-tile;Function ;5_3_Graphics_Context_Attributes.html#gcontext-tile;",
"XLIB;gcontext-ts-x;Function ;5_3_Graphics_Context_Attributes.html#gcontext-ts-x;",
"XLIB;gcontext-ts-y;Function ;5_3_Graphics_Context_Attributes.html#gcontext-ts-y;",
"XLIB;get-external-event-code;Function;17_Undocmented.html#get-external-event-code;",
"XLIB;get-image;Function ;7_3_Image_Functions.html#get-image;",
"XLIB;get-property;Function ;11_2_Properties.html#get-property;",
"XLIB;get-raw-image;Function ;7_5_Direct_Image_Transfer.html#get-raw-image;",
"XLIB;get-resource;Function ;13_4_3_Resource_Access_Functions.html#get-resource;",
"XLIB;get-search-resource;Function ;13_4_3_Resource_Access_Functions.html#get-search-resource;",
"XLIB;get-search-table;Function ;13_4_3_Resource_Access_Functions.html#get-search-table;",
"XLIB;get-standard-colormap;Function;17_Undocmented.html#get-standard-colormap;",
"XLIB;get-wm-class;Function;17_Undocmented.html#get-wm-class;",
"XLIB;global-pointer-position;Function ;12_6_Pointer_Position.html#global-pointer-position;",
"XLIB;grab-button;Function ;12_9_Grabbing_a_Button.html#grab-button;",
"XLIB;grab-key;Function ;12_11_Grabbing_a_Key.html#grab-key;",
"XLIB;grab-keyboard;Function ;12_10_Grabbing_the_Keyboard.html#grab-keyboard;",
"XLIB;grab-pointer;Function ;12_8_Grabbing_the_Pointer.html#grab-pointer;",
"XLIB;grab-server;Function ;14_1_Grabbing_the_Server.html#grab-server;",
"XLIB;grab-status;Type ;1_6_Data_Types.html#grab-status;",
"XLIB;:graphics-exposure;Event Type ;12_12_4_Exposure_Events.html#:graphics-exposure;",
"XLIB;:gravity-notify;Event Type ;12_12_5_Window_State_Events.html#:gravity-notify;",
"XLIB;green-mask;Slots of visual-info ;1_6_Data_Types.html#green-mask;",
"XLIB;handler-function;Function ;12_3_Processing_Events.html#handler-function;",
"XLIB;iconify-window;Function;17_Undocmented.html#iconify-window;",
"XLIB;icon-sizes;Function;17_Undocmented.html#icon-sizes;",
"XLIB;id;Slot of visual-info ;1_6_Data_Types.html#id;",
"XLIB;id-choice-error;Condition ;16_1_Introduction.html#id-choice-error;",
"XLIB;image-blue-mask;Function ;7_2_1_Basic_Images.html#image-blue-mask;",
"XLIB;image-depth;Function ;7_2_1_Basic_Images.html#image-depth;",
"XLIB;image-depth;Type ;1_6_Data_Types.html#image-depth;",
"XLIB;image-green-mask;Function ;7_2_1_Basic_Images.html#image-green-mask;",
"XLIB;image-height;Function ;7_2_1_Basic_Images.html#image-height;",
"XLIB;image-name;Function ;7_2_1_Basic_Images.html#image-name;",
"XLIB;image-plist;Function ;7_2_1_Basic_Images.html#image-plist;",
"XLIB;image-red-mask;Function ;7_2_1_Basic_Images.html#image-red-mask;",
"XLIB;image-width;Function ;7_2_1_Basic_Images.html#image-width;",
"XLIB;image-x-hot;Function ;7_2_1_Basic_Images.html#image-x-hot;",
"XLIB;image-xy-bitmap-list;Function ;7_2_2_XY-Format_Images.html#image-xy-bitmap-list;",
"XLIB;image-y-hot;Function ;7_2_1_Basic_Images.html#image-y-hot;",
"XLIB;image-z-bits-per-pixel;Function ;7_2_3_Z-Format_Images.html#image-z-bits-per-pixel;",
"XLIB;image-z-pixarray;Function ;7_2_3_Z-Format_Images.html#image-z-pixarray;",
"XLIB;implementation-error;Condition ;16_1_Introduction.html#implementation-error;",
"XLIB;index-size;Type ;1_6_Data_Types.html#index-size;",
"XLIB;input-focus;Function ;12_7_Managing_Input_Focus.html#input-focus;",
"XLIB;install-colormap;Function ;9_3_2_Installing_Colormaps.html#install-colormap;",
"XLIB;installed-colormaps;Function ;9_3_2_Installing_Colormaps.html#installed-colormaps;",
"XLIB;int16;Type ;1_6_Data_Types.html#int16;",
"XLIB;int32;Type ;1_6_Data_Types.html#int32;",
"XLIB;int8;Type ;1_6_Data_Types.html#int8;",
"XLIB;intern-atom;Function ;11_1_Atoms.html#intern-atom;",
"XLIB;keyboard-control;Function ;14_3_Keyboard_Control.html#keyboard-control;",
"XLIB;keyboard-mapping;Function ;14_4_2_Keyboard_Mapping.html#keyboard-mapping;",
"XLIB;keycode->keysym;Function ;14_4_3_Using_Keycodes_and_Keysyms.html#keycode->keysym;",
"XLIB;:keymap-notify;Event Type ;12_12_3_Keyboard_and_Pointer_State_Events.html#:keymap-notify;",
"XLIB;:key-press;Event Type ;12_12_1_Keyboard_and_Pointer_Events.html#:key-press;",
"XLIB;:key-release;Event Type ;12_12_1_Keyboard_and_Pointer_Events.html#:key-release;",
"XLIB;keysym;Type ;1_6_Data_Types.html#keysym;",
"XLIB;keysym->character;Function ;14_4_3_Using_Keycodes_and_Keysyms.html#keysym->character;",
"XLIB;keysym-in-map-p;Function;17_Undocmented.html#keysym-in-map-p;",
"XLIB;keysym->keycodes;Function;17_Undocmented.html#keysym->keycodes;",
"XLIB;keysym-set;Function;17_Undocmented.html#keysym-set;",
"XLIB;kill-client;Function ;14_5_Client_Termination.html#kill-client;",
"XLIB;kill-temporary-clients;Function ;14_5_Client_Termination.html#kill-temporary-clients;",
"XLIB;:leave-notify;Event Type ;12_12_1_Keyboard_and_Pointer_Events.html#:leave-notify;",
"XLIB;length-error;Condition ;16_1_Introduction.html#length-error;",
"XLIB;list-extensions;Function ;15_1_Extensions.html#list-extensions;",
"XLIB;list-font-names;Function ;8_3_Listing_Fonts.html#list-font-names;",
"XLIB;list-fonts;Function ;8_3_Listing_Fonts.html#list-fonts;",
"XLIB;list-properties;Function ;11_2_Properties.html#list-properties;",
"XLIB;lookup-color;Function ;9_3_4_Finding_Colors.html#lookup-color;",
"XLIB;lookup-error;Condition ;16_1_Introduction.html#lookup-error;",
"XLIB;lsb-first-p;Slot of bitmap-format ;1_6_Data_Types.html#lsb-first-p;",
"XLIB;make-color;Function ;9_2_Color_Functions.html#make-color;",
"XLIB;make-event-keys;Function ;1_6_Data_Types.html#make-event-keys;",
"XLIB;make-event-mask;Function ;1_6_Data_Types.html#make-event-mask;",
"XLIB;make-resource-database;Function ;13_3_Basic_Resource_Database_Functions.html#make-resource-database;",
"XLIB;make-state-keys;Function ;1_6_Data_Types.html#make-state-keys;",
"XLIB;make-state-mask;Function ;1_6_Data_Types.html#make-state-mask;",
"XLIB;:map-notify;Event Type ;12_12_5_Window_State_Events.html#:map-notify;",
"XLIB;mapping-notify;Function ;17_Undocmented.html#mapping-notify;",
"XLIB;:mapping-notify;Event Type ;12_12_3_Keyboard_and_Pointer_State_Events.html#:mapping-notify;",
"XLIB;:map-request;Event Type ;12_12_6_Structure_Control_Events.html#:map-request;",
"XLIB;map-resource;Function ;13_3_Basic_Resource_Database_Functions.html#map-resource;",
"XLIB;map-subwindows;Function ;4_6_Mapping_Windows.html#map-subwindows;",
"XLIB;map-window;Function ;4_6_Mapping_Windows.html#map-window;",
"XLIB;mask16;Type ;1_6_Data_Types.html#mask16;",
"XLIB;mask32;Type ;1_6_Data_Types.html#mask32;",
"XLIB;match-error;Condition ;16_1_Introduction.html#match-error;",
"XLIB;max-char-ascent;Function ;8_4_Font_Attributes.html#max-char-ascent;",
"XLIB;max-char-attributes;Function ;8_4_Font_Attributes.html#max-char-attributes;",
"XLIB;max-char-descent;Function ;8_4_Font_Attributes.html#max-char-descent;",
"XLIB;max-char-left-bearing;Function ;8_4_Font_Attributes.html#max-char-left-bearing;",
"XLIB;max-char-right-bearing;Function ;8_4_Font_Attributes.html#max-char-right-bearing;",
"XLIB;max-char-width;Function ;8_4_Font_Attributes.html#max-char-width;",
"XLIB;merge-resources;Function ;13_3_Basic_Resource_Database_Functions.html#merge-resources;",
"XLIB;min-char-ascent;Function ;8_4_Font_Attributes.html#min-char-ascent;",
"XLIB;min-char-attributes;Function ;8_4_Font_Attributes.html#min-char-attributes;",
"XLIB;min-char-descent;Function ;8_4_Font_Attributes.html#min-char-descent;",
"XLIB;min-char-left-bearing;Function ;8_4_Font_Attributes.html#min-char-left-bearing;",
"XLIB;min-char-right-bearing;Function ;8_4_Font_Attributes.html#min-char-right-bearing;",
"XLIB;min-char-width;Function ;8_4_Font_Attributes.html#min-char-width;",
"XLIB;missing-parameter;Condition ;16_1_Introduction.html#missing-parameter;",
"XLIB;modifier-key;Type ;1_6_Data_Types.html#modifier-key;",
"XLIB;modifier-mapping;Function ;14_3_Keyboard_Control.html#modifier-mapping;",
"XLIB;modifier-mask;Type ;1_6_Data_Types.html#modifier-mask;",
"XLIB;motion-events;Function ;12_6_Pointer_Position.html#motion-events;",
"XLIB;:motion-notify;Event Type ;12_12_1_Keyboard_and_Pointer_Events.html#:motion-notify;",
"XLIB;name-error;Condition ;16_1_Introduction.html#name-error;",
"XLIB;:no-exposure;Event Type ;12_12_4_Exposure_Events.html#:no-exposure;",
"XLIB;no-operation;Function;17_Undocmented.html#no-operation;",
"XLIB;open-display;Function ;2_2_Opening_the_Display.html#open-display;",
"XLIB;open-font;Function ;8_2_Opening_Fonts.html#open-font;",
"XLIB;pad;Slot of bitmap-format ;1_6_Data_Types.html#pad;",
"XLIB;parse-color;Function;17_Undocmented.html#parse-color;",
"XLIB;pixarray;Type ;1_6_Data_Types.html#pixarray;",
"XLIB;pixel;Type ;1_6_Data_Types.html#pixel;",
"XLIB;pixmap;Type ;1_6_Data_Types.html#pixmap;",
"XLIB;pixmap-display;Function ;4_8_Pixmaps.html#pixmap-display;",
"XLIB;pixmap-equal;Function ;4_8_Pixmaps.html#pixmap-equal;",
"XLIB;pixmap-error;Condition ;16_1_Introduction.html#pixmap-error;",
"XLIB;pixmap-format;Structure ;1_6_Data_Types.html#pixmap-format;",
"XLIB;pixmap-id;Function ;4_8_Pixmaps.html#pixmap-id;",
"XLIB;pixmap-p;Function ;4_8_Pixmaps.html#pixmap-p;",
"XLIB;pixmap-plist;Function ;4_8_Pixmaps.html#pixmap-plist;",
"XLIB;pointer-control;Function ;14_2_Pointer_Control.html#pointer-control;",
"XLIB;pointer-event-mask;Type ;1_6_Data_Types.html#pointer-event-mask;",
"XLIB;pointer-event-mask-class;Type ;1_6_Data_Types.html#pointer-event-mask-class;",
"XLIB;pointer-mapping;Function ;14_2_Pointer_Control.html#pointer-mapping;",
"XLIB;pointer-position;Function ;12_6_Pointer_Position.html#pointer-position;",
"XLIB;point-seq;Type ;1_6_Data_Types.html#point-seq;",
"XLIB;process-event;Function ;12_3_Processing_Events.html#process-event;",
"XLIB;:property-notify;Event Type ;12_12_7_Client_Communications_Events.html#:property-notify;",
"XLIB;put-image;Function ;7_3_Image_Functions.html#put-image;",
"XLIB;put-raw-image;Function ;7_5_Direct_Image_Transfer.html#put-raw-image;",
"XLIB;query-best-cursor;Function ;10_3_Cursor_Functions.html#query-best-cursor;",
"XLIB;query-best-stipple;Function ;5_3_Graphics_Context_Attributes.html#query-best-stipple;",
"XLIB;query-best-tile;Function ;5_3_Graphics_Context_Attributes.html#query-best-tile;",
"XLIB;query-colors;Function ;9_3_4_Finding_Colors.html#query-colors;",
"XLIB;query-extension;Function ;15_1_Extensions.html#query-extension;",
"XLIB;query-keymap;Function ;14_3_Keyboard_Control.html#query-keymap;",
"XLIB;query-pointer;Function ;12_6_Pointer_Position.html#query-pointer;",
"XLIB;query-tree;Function ;4_5_Window_Hierarchy.html#query-tree;",
"XLIB;queue-event;Function ;12_4_Managing_the_Event_Queue.html#queue-event;",
"XLIB;read-bitmap-file;Function ;7_4_Image_Files.html#read-bitmap-file;",
"XLIB;read-resources;Function ;13_5_Resource_Database_Files.html#read-resources;",
"XLIB;recolor-cursor;Function ;10_3_Cursor_Functions.html#recolor-cursor;",
"XLIB;rect-seq;Type ;1_6_Data_Types.html#rect-seq;",
"XLIB;red-mask;Slots of visual-info ;1_6_Data_Types.html#red-mask;",
"XLIB;remove-access-host;Function ;14_6_Managing_Host_Access.html#remove-access-host;",
"XLIB;remove-from-save-set;Function ;14_5_Client_Termination.html#remove-from-save-set;",
"XLIB;render-add-glyph;Function ;15_3_3_Glyphs_and_Glyphsets.html#render-add-glyph;",
"XLIB;render-add-glyph-from-picture;Function ;15_3_3_Glyphs_and_Glyphsets.html#render-add-glyph-from-picture;",
"XLIB;render-composite-glyph;Function ;15_3_4_Using_glyphs.html#render-composite-glyph;",
"XLIB;render-create-glyph-set;Function ;15_3_3_Glyphs_and_Glyphsets.html#render-create-glyph-set;",
"XLIB;render-create-picture;Function ;15_3_2_The_picture_object.html#render-create-picture;",
"XLIB;render-free-glyphs;Function ;15_3_3_Glyphs_and_Glyphsets.html#render-free-glyphs;",
"XLIB;render-free-glyph-set;Function ;15_3_3_Glyphs_and_Glyphsets.html#render-free-glyph-set;",
"XLIB;render-free-picture;Function ;15_3_2_The_picture_object.html#render-free-picture;",
"XLIB;render-reference-glyph-set;Function ;15_3_3_Glyphs_and_Glyphsets.html#render-reference-glyph-set;",
"XLIB;:reparent-notify;Event Type ;12_12_5_Window_State_Events.html#:reparent-notify;",
"XLIB;reparent-window;Function ;4_5_Window_Hierarchy.html#reparent-window;",
"XLIB;repeat-seq;Type ;1_6_Data_Types.html#repeat-seq;",
"XLIB;reply-length-error;Condition ;16_1_Introduction.html#reply-length-error;",
"XLIB;reply-timeout;Condition ;16_1_Introduction.html#reply-timeout;",
"XLIB;request-error;Condition ;16_1_Introduction.html#request-error;",
"XLIB;reset-screen-saver;Function ;14_7_Screen_Saver.html#reset-screen-saver;",
"XLIB;:resize-request;Event Type ;12_12_6_Structure_Control_Events.html#:resize-request;",
"XLIB;resource-database-timestamp;Function;17_Undocmented.html#resource-database-timestamp;",
"XLIB;resource-error;Condition ;16_1_Introduction.html#resource-error;",
"XLIB;resource-id;Type ;1_6_Data_Types.html#resource-id;",
"XLIB;resource-key;Function;17_Undocmented.html#resource-key;",
"XLIB;rgb-colormaps;Function;17_Undocmented.html#rgb-colormaps;",
"XLIB;rgb-val;Type ;1_6_Data_Types.html#rgb-val;",
"XLIB;root-resources;Function ;17_Undocmented.html#root-resources;",
"XLIB;rotate-cut-buffers;Function;17_Undocmented.html#rotate-cut-buffers;",
"XLIB;rotate-properties;Function ;11_2_Properties.html#rotate-properties;",
"XLIB;scanline-pad;Slot of pixmap-format ;1_6_Data_Types.html#scanline-pad;",
"XLIB;screen;Type ;1_6_Data_Types.html#screen;",
"XLIB;screen-backing-stores;Function ;3_2_Screen_Attributes.html#screen-backing-stores;",
"XLIB;screen-black-pixel;Function ;3_2_Screen_Attributes.html#screen-black-pixel;",
"XLIB;screen-default-colormap;Function ;3_2_Screen_Attributes.html#screen-default-colormap;",
"XLIB;screen-depths;Function ;3_2_Screen_Attributes.html#screen-depths;",
"XLIB;screen-event-mask-at-open;Function ;3_2_Screen_Attributes.html#screen-event-mask-at-open;",
"XLIB;screen-height;Function ;3_2_Screen_Attributes.html#screen-height;",
"XLIB;screen-height-in-millimeters;Function ;3_2_Screen_Attributes.html#screen-height-in-millimeters;",
"XLIB;screen-max-installed-maps;Function ;3_2_Screen_Attributes.html#screen-max-installed-maps;",
"XLIB;screen-min-installed-maps;Function ;3_2_Screen_Attributes.html#screen-min-installed-maps;",
"XLIB;screen-p;Function ;3_2_Screen_Attributes.html#screen-p;",
"XLIB;screen-plist;Function ;3_2_Screen_Attributes.html#screen-plist;",
"XLIB;screen-root;Function ;3_2_Screen_Attributes.html#screen-root;",
"XLIB;screen-root-depth;Function ;3_2_Screen_Attributes.html#screen-root-depth;",
"XLIB;screen-root-visual;Function ;3_2_Screen_Attributes.html#screen-root-visual;",
"XLIB;screen-saver;Function ;14_7_Screen_Saver.html#screen-saver;",
"XLIB;screen-save-unders-p;Function ;3_2_Screen_Attributes.html#screen-save-unders-p;",
"XLIB;screen-white-pixel;Function ;3_2_Screen_Attributes.html#screen-white-pixel;",
"XLIB;screen-width;Function ;3_2_Screen_Attributes.html#screen-width;",
"XLIB;screen-width-in-millimeters;Function ;3_2_Screen_Attributes.html#screen-width-in-millimeters;",
"XLIB;seg-seq;Type ;1_6_Data_Types.html#seg-seq;",
"XLIB;:selection-clear;Event Type ;12_12_7_Client_Communications_Events.html#:selection-clear;",
"XLIB;:selection-notify;Event Type ;12_12_7_Client_Communications_Events.html#:selection-notify;",
"XLIB;selection-owner;Function ;11_3_Selections.html#selection-owner;",
"XLIB;:selection-request;Event Type ;12_12_7_Client_Communications_Events.html#:selection-request;",
"XLIB;send-event;Function ;12_5_Sending_Events.html#send-event;",
"XLIB;sequence-error;Condition ;16_1_Introduction.html#sequence-error;",
"XLIB;server-disconnect;Condition ;16_1_Introduction.html#server-disconnect;",
"XLIB;set-access-control;Function;17_Undocmented.html#set-access-control;",
"XLIB;set-close-down-mode;Function;17_Undocmented.html#set-close-down-mode;",
"XLIB;setf (window-cursor);Function ;4_3_Window_Attributes.html#setf (window-cursor);",
"XLIB;set-input-focus;Function ;12_7_Managing_Input_Focus.html#set-input-focus;",
"XLIB;set-modifier-mapping;Function ;14_3_Keyboard_Control.html#set-modifier-mapping;",
"XLIB;set-pointer-mapping;Function;17_Undocmented.html#set-pointer-mapping;",
"XLIB;set-screen-saver;Function ;14_7_Screen_Saver.html#set-screen-saver;",
"XLIB;set-selection-owner;Function;17_Undocmented.html#set-selection-owner;",
"XLIB;set-standard-colormap;Function;17_Undocmented.html#set-standard-colormap;",
"XLIB;set-standard-properties;Function;17_Undocmented.html#set-standard-properties;",
"XLIB;set-wm-class;Function;17_Undocmented.html#set-wm-class;",
"XLIB;set-wm-properties;Function;17_Undocmented.html#set-wm-properties;",
"XLIB;set-wm-resources;Function;17_Undocmented.html#set-wm-resources;",
"XLIB;state-mask-key;Type ;1_6_Data_Types.html#state-mask-key;",
"XLIB;store-color;Function ;9_3_5_Changing_Colors.html#store-color;",
"XLIB;store-colors;Function ;9_3_5_Changing_Colors.html#store-colors;",
"XLIB;stringable;Type ;1_6_Data_Types.html#stringable;",
"XLIB;text-extents;Function ;8_6_Querying_Text_Size.html#text-extents;",
"XLIB;text-width;Function ;8_6_Querying_Text_Size.html#text-width;",
"XLIB;timestamp;Type ;1_6_Data_Types.html#timestamp;",
"XLIB;transient-for;Function;17_Undocmented.html#transient-for;",
"XLIB;translate-coordinates;Function ;4_5_Window_Hierarchy.html#translate-coordinates;",
"XLIB;translate-default;Function;17_Undocmented.html#translate-default;",
"XLIB;translate-function;Function ;6_7_Drawing_Text.html#translate-function;",
"XLIB;undefine-keysym;Function;17_Undocmented.html#undefine-keysym;",
"XLIB;unexpected-reply;Condition ;16_1_Introduction.html#unexpected-reply;",
"XLIB;ungrab-button;Function ;12_9_Grabbing_a_Button.html#ungrab-button;",
"XLIB;ungrab-key;Function ;12_11_Grabbing_a_Key.html#ungrab-key;",
"XLIB;ungrab-keyboard;Function ;12_10_Grabbing_the_Keyboard.html#ungrab-keyboard;",
"XLIB;ungrab-pointer;Function ;12_8_Grabbing_the_Pointer.html#ungrab-pointer;",
"XLIB;ungrab-server;Function ;14_1_Grabbing_the_Server.html#ungrab-server;",
"XLIB;uninstall-colormap;Function ;9_3_2_Installing_Colormaps.html#uninstall-colormap;",
"XLIB;unit;Slot of bitmap-format ;1_6_Data_Types.html#unit;",
"XLIB;unknown-error;Condition ;16_1_Introduction.html#unknown-error;",
"XLIB;:unmap-notify;Event Type ;12_12_5_Window_State_Events.html#:unmap-notify;",
"XLIB;unmap-subwindows;Function ;4_6_Mapping_Windows.html#unmap-subwindows;",
"XLIB;unmap-window;Function ;4_6_Mapping_Windows.html#unmap-window;",
"XLIB;value-error;Condition ;16_1_Introduction.html#value-error;",
"XLIB;:visibility-notify;Event Type ;12_12_5_Window_State_Events.html#:visibility-notify;",
"XLIB;visual-info;Structure ;1_6_Data_Types.html#visual-info;",
"XLIB;visual-info-blue-mask;Function;17_Undocmented.html#visual-info-blue-mask;",
"XLIB;visual-info-green-mask;Function;17_Undocmented.html#visual-info-green-mask;",
"XLIB;visual-info-red-mask;Function;17_Undocmented.html#visual-info-red-mask;",
"XLIB;warp-pointer;Function ;12_6_Pointer_Position.html#warp-pointer;",
"XLIB;warp-pointer-if-inside;Function ;12_6_Pointer_Position.html#warp-pointer-if-inside;",
"XLIB;warp-pointer-relative;Function ;12_6_Pointer_Position.html#warp-pointer-relative;",
"XLIB;warp-pointer-relative-if-inside;Function ;12_6_Pointer_Position.html#warp-pointer-relative-if-inside;",
"XLIB;window;Type ;1_6_Data_Types.html#window;",
"XLIB;window-all-event-masks;Function ;4_3_Window_Attributes.html#window-all-event-masks;",
"XLIB;window-backing-pixel;Function ;4_3_Window_Attributes.html#window-backing-pixel;",
"XLIB;window-backing-planes;Function ;4_3_Window_Attributes.html#window-backing-planes;",
"XLIB;window-backing-store;Function ;4_3_Window_Attributes.html#window-backing-store;",
"XLIB;window-bit-gravity;Function ;4_3_Window_Attributes.html#window-bit-gravity;",
"XLIB;window-class;Function ;4_3_Window_Attributes.html#window-class;",
"XLIB;window-colormap;Function ;4_3_Window_Attributes.html#window-colormap;",
"XLIB;window-colormap-installed-p;Function ;4_3_Window_Attributes.html#window-colormap-installed-p;",
"XLIB;window-cursor;Function;17_Undocmented.html#window-cursor;",
"XLIB;window-display;Function ;4_3_Window_Attributes.html#window-display;",
"XLIB;window-do-not-propagate-mask;Function ;4_3_Window_Attributes.html#window-do-not-propagate-mask;",
"XLIB;window-equal;Function ;4_3_Window_Attributes.html#window-equal;",
"XLIB;window-error;Condition ;16_1_Introduction.html#window-error;",
"XLIB;window-event-mask;Function ;4_3_Window_Attributes.html#window-event-mask;",
"XLIB;window-gravity;Function ;4_3_Window_Attributes.html#window-gravity;",
"XLIB;window-id;Function ;4_3_Window_Attributes.html#window-id;",
"XLIB;window-map-state;Function ;4_3_Window_Attributes.html#window-map-state;",
"XLIB;window-override-redirect;Function ;4_3_Window_Attributes.html#window-override-redirect;",
"XLIB;window-p;Function ;4_3_Window_Attributes.html#window-p;",
"XLIB;window-plist;Function ;4_3_Window_Attributes.html#window-plist;",
"XLIB;window-save-under;Function ;4_3_Window_Attributes.html#window-save-under;",
"XLIB;window-visual;Function ;4_3_Window_Attributes.html#window-visual;",
"XLIB;window-visual-info;Function;17_Undocmented.html#window-visual-info;",
"XLIB;win-gravity;Type ;1_6_Data_Types.html#win-gravity;",
"XLIB;with-display;Macro ;2_3_Display_Attributes.html#with-display;",
"XLIB;withdraw-window;Function;17_Undocmented.html#withdraw-window;",
"XLIB;with-event-queue;Macro ;12_4_Managing_the_Event_Queue.html#with-event-queue;",
"XLIB;with-gcontext;Macro ;5_6_Graphics_Context_Cache.html#with-gcontext;",
"XLIB;with-server-grabbed;Macro ;14_1_Grabbing_the_Server.html#with-server-grabbed;",
"XLIB;with-state;Macro ;4_3_Window_Attributes.html#with-state;",
"XLIB;wm-client-machine;Function;17_Undocmented.html#wm-client-machine;",
"XLIB;wm-colormap-windows;Function;17_Undocmented.html#wm-colormap-windows;",
"XLIB;wm-command;Function;17_Undocmented.html#wm-command;",
"XLIB;wm-hints;Function;17_Undocmented.html#wm-hints;",
"XLIB;wm-hints-flags;Function;17_Undocmented.html#wm-hints-flags;",
"XLIB;wm-icon-name;Function;17_Undocmented.html#wm-icon-name;",
"XLIB;wm-name;Function;17_Undocmented.html#wm-name;",
"XLIB;wm-normal-hints;Function;17_Undocmented.html#wm-normal-hints;",
"XLIB;wm-protocols;Function;17_Undocmented.html#wm-protocols;",
"XLIB;wm-resources;Function;17_Undocmented.html#wm-resources;",
"XLIB;wm-zoom-hints;Function;17_Undocmented.html#wm-zoom-hints;",
"XLIB;write-bitmap-file;Function ;7_4_Image_Files.html#write-bitmap-file;",
"XLIB;write-resources;Function ;13_5_Resource_Database_Files.html#write-resources;",
"XLIB;xatom;Type ;1_6_Data_Types.html#xatom;",
"XLIB;x-error;Condition ;16_1_Introduction.html#x-error;"
# ################
#"XLIB;bell;Dellys Klingel;hallo.html",
);

$keyword = param("q");

if (!defined ($keyword)) {
  $keyword = "";
}

$keyword = lc($keyword);   # lowercase
chomp($keyword);           # remove trailing newline if any
$i = index($keyword, ":"); # check for a preceeding package name
if ($i > 0) {              # exclude i == 0 which indicates a constant
  $i = $i + 1;
  $len = length($keyword) - $i;
  $keyword = substr($keyword, $i, $len);
}
$keyword =~ s/^\s+//;     # delete space chars at the beginning
$keyword =~ s/\s+$//;     # delete space chars at the end

print ("keyword: $keyword\n");

@url_lines =  grep (/\;$keyword\;/i, @lines);

if (defined (@url_lines) && scalar(@url_lines) == 1) {

  $right_line = $url_lines[0];
  %right_tokens = get_items_related_to_keyword($right_line);
  $right_token = $right_tokens{"url"};
  http_302_with_url($right_token);
} elsif (defined (@url_lines) && scalar (@url_lines) > 1) {

  create_choose_hit_page(@url_lines);
} else {

  create_not_found_page($keyword);
}


sub http_302_with_url {
  my($document_url) = @_;
  my ($what_i_mean_base_url) = create_my_base_url();

  print ("Status: 302 Moved temporarily\r\n");
  print ("Content-type: text/plain\r\n");
  print ("Location: $what_i_mean_base_url$document_url\r\n\r\n");
  return 1;
}


sub create_not_found_page{
  my ($key, @links) = @_;
  my ($what_i_mean_base_url) = create_my_base_url();
  my ($script_url) = url();
  my (@matching_keywords_substring_search) = substring_search($key);
  my ($line);

  print_content_type_text_html();
  print_header("Not Found", "Not found: $key");
  print("<form action=\"$script_url\" method=\"get\">\r\n");
  print("Apropos:\r\n");
  print("<input maxlength=\"100\" size=\"35\" name=\"q\" value=\"$key\" type=\"text\">\r\n");
  print("</form>\r\n");
  print("\r\n");

  if (scalar(@matching_keywords_substring_search) > 0) {
    print("<p>\r\n");
    print("Or choose a topic (substring search):\r\n");
    print("</p>\r\n");
    print("<ul>\r\n");
    foreach $line (@matching_keywords_substring_search) {
      my (%tokens) = %{$line};
      my ($keyword) = $tokens{"keyword"};
      my ($kind) = $tokens{"kind"};
      my ($url) = $tokens{"url"};

      print ("<li><a href=\"$what_i_mean_base_url$url\"><b>$keyword</b></a>, <i>$kind</i></li>\r\n");
    }
    print("</ul>\r\n");
  }

  print_footer();
}

sub create_choose_hit_page {
  my (@lines) = @_;
  my ($line);
  my ($what_i_mean_base_url) = create_my_base_url();

  @lines = convert_items_from_string_to_hashtable(@lines);

  print_content_type_text_html();
  print_header("Choose proper hit", "Please choose the right hit:");

  print("<ul>\r\n");
  foreach $line (@lines) {
    my (%tokens) = %{$line};
    my ($keyword) = $tokens{"keyword"};
    my ($kind) = $tokens{"kind"};
    my ($url) = $tokens{"url"};

    print("<li><a href=\"$what_i_mean_base_url$url\"><b>$keyword</b></a>, <i>$kind</i></li>\r\n");
  }
  print("</ul>\r\n");

  print_footer();
}

sub closest_n_keywords {
  my($n, $key) = @_;
  #does nothing at the moment. But may do something in the future.
}

sub substring_search {
  my($the_string) = @_;
  my ($line);
  my (@substrings);

  if ($the_string =~ /.*\-.*/ ||   # check if the_string contains a dash
      $the_string =~ /^:/) {       # or the_str begins with ":"
    foreach $line (@lines) {
      my (%line_items) = get_items_related_to_keyword($line);
      my ($kword) = $line_items{"keyword"};

      my ($i) = index($kword, $the_string);
      if ($i >= 0) {
	push(@substrings, \%line_items);
      }
    }
  } else {
    foreach $line (@lines) {
      my (%line_items) = get_items_related_to_keyword($line);
      my ($kword) = $line_items{"keyword"};
      $kword =~ s/://;  # ignore leading ':'

      my (@kword_components) = split(/-/,$kword);
      my (@lines_beginning_with_the_string) = grep (/\b$the_string/, @kword_components);
      if (scalar (@lines_beginning_with_the_string) > 0) {
	push (@substrings, \%line_items);
      }
    }
  }

  return @substrings;
}

sub get_items_related_to_keyword {
  my($line) = @_;
  my(@tokens);
  my (%tokenshash);
  my($right_token);
  my($i);

  @tokens = split(/\;/, $line);

  %tokenshash = ("package", $tokens[0], "keyword", $tokens[1], "kind", $tokens[2], "url", $tokens[3]);
  return %tokenshash;
}

sub convert_items_from_string_to_hashtable {
  my (@stringlist) = @_;
  my ($line);
  my (@res);

  foreach $line (@stringlist) {
    my (%line_items) = get_items_related_to_keyword($line);
    push (@res, \%line_items);
  }

  return @res;
}


sub create_my_base_url {
  my ($myurl);
  my($relative_url);
  my($what_i_mean_base_url);
  my ($i);

  # xxx
  # return "http://www.uni-karlsruhe.de/%7eunk6/clxman/";

  $myurl = url();
  $relative_url  = url(-relative=>1);
  $i = index($myurl, $relative_url);
  $what_i_mean_base_url = substr($myurl, 0, $i);

  return $what_i_mean_base_url;
}

sub print_content_type_text_html {
  print("Content-type: text/html\r\n");
  print("\r\n");
}

sub print_header {
  my ($title, $h1_tag) = @_;
  print("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n");
  print("<html>\r\n");
  print("<head>\r\n");
  print("<title>$title</title>\r\n");
  print("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n");
  print ("<LINK REL=\"Stylesheet\" TYPE=\"text/css\" HREF=\"clxman.css\">\r\n");
  print("</head>\r\n");
  print("\r\n");
  print("<body>\r\n");
  print("<h1>$h1_tag</h1>\r\n");
}

sub print_footer {
  print("\r\n");
}
